# Class BufferedImageFilter

java.lang.Object
java.awt.image.ImageFilter
java.awt.image.BufferedImageFilter

All Implemented Interfaces:
  `ImageConsumer, Cloneable`

public class BufferedImageFilter extends ImageFilter implements Cloneable
The `BufferedImageFilter` class subclasses an `ImageFilter` to provide a simple means of using a single-source/single-destination image operator (`BufferedImageOp`) to filter a `BufferedImage` in the Image Producer/Consumer/Observer paradigm. Examples of these image operators are: `ConvolveOp`, `AffineTransformOp` and `LookupOp`.

See Also:
  - `ImageFilter`
  - `BufferedImage`
  - `BufferedImageOp`

- ## Field Summary

  ### Fields declared in class ImageFilter

  `consumer`
  Modifier and Type
  Field
  Description
  `protected ImageConsumer`
  `consumer`
  The consumer of the particular image data stream for which this instance of the ImageFilter is filtering data.

  ### Fields declared in interface ImageConsumer

  `COMPLETESCANLINES, IMAGEABORTED, IMAGEERROR, RANDOMPIXELORDER, SINGLEFRAME, SINGLEFRAMEDONE, SINGLEPASS, STATICIMAGEDONE, TOPDOWNLEFTRIGHT`
  Modifier and Type
  Field
  Description
  `static final int`
  `COMPLETESCANLINES`
  The pixels will be delivered in (multiples of) complete scanlines at a time.
  `static final int`
  `IMAGEABORTED`
  The image creation process was deliberately aborted.
  `static final int`
  `IMAGEERROR`
  An error was encountered while producing the image.
  `static final int`
  `RANDOMPIXELORDER`
  The pixels will be delivered in a random order.
  `static final int`
  `SINGLEFRAME`
  The image contain a single static image.
  `static final int`
  `SINGLEFRAMEDONE`
  One frame of the image is complete but there are more frames to be delivered.
  `static final int`
  `SINGLEPASS`
  The pixels will be delivered in a single pass.
  `static final int`
  `STATICIMAGEDONE`
  The image is complete and there are no more pixels or frames to be delivered.
  `static final int`
  `TOPDOWNLEFTRIGHT`
  The pixels will be delivered in top-down, left-to-right order.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BufferedImageFilter(BufferedImageOp op)`
  Constructs a `BufferedImageFilter` with the specified single-source/single-destination operator.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `BufferedImageOp`
  `getBufferedImageOp()`
  Returns the `BufferedImageOp`.
  `void`
  `imageComplete(int status)`
  Filters the information provided in the `imageComplete` method of the `ImageConsumer` interface.
  `void`
  `setColorModel(ColorModel model)`
  Filters the information provided in the `setColorModel` method of the `ImageConsumer` interface.
  `void`
  `setDimensions(int width, int height)`
  Filters the information provided in the `setDimensions` method of the `ImageConsumer` interface.
  `void`
  `setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize)`
  Filters the information provided in the `setPixels` method of the `ImageConsumer` interface which takes an array of bytes.
  `void`
  `setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize)`
  Filters the information provided in the `setPixels` method of the `ImageConsumer` interface which takes an array of integers.

  ### Methods declared in class ImageFilter

  `clone, getFilterInstance, resendTopDownLeftRight, setHints, setProperties`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Clones this object.
  `ImageFilter`
  `getFilterInstance(ImageConsumer ic)`
  Returns a unique instance of an ImageFilter object which will actually perform the filtering for the specified ImageConsumer.
  `void`
  `resendTopDownLeftRight(ImageProducer ip)`
  Responds to a request for a TopDownLeftRight (TDLR) ordered resend of the pixel data from an `ImageConsumer`.
  `void`
  `setHints(int hints)`
  Filters the information provided in the setHints method of the ImageConsumer interface.
  `void`
  `setProperties(Hashtable<?,?> props)`
  Passes the properties from the source object along after adding a property indicating the stream of filters it has been run through.

  ### Methods declared in class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### BufferedImageFilter

    public BufferedImageFilter(BufferedImageOp op)
    Constructs a `BufferedImageFilter` with the specified single-source/single-destination operator.
    Parameters:
      `op` - the specified `BufferedImageOp` to use to filter a `BufferedImage`
    Throws:
      `NullPointerException` - if op is null

- ## Method Details

  - ### getBufferedImageOp

    public BufferedImageOp getBufferedImageOp()
    Returns the `BufferedImageOp`.
    Returns:
      the operator of this `BufferedImageFilter`.

  - ### setDimensions

    public void setDimensions(int width, int height)
    Filters the information provided in the `setDimensions` method of the `ImageConsumer` interface.

    Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to retrieve pixels from an image should avoid calling this method directly since that operation could result in problems with retrieving the requested pixels.

    Specified by:
      `setDimensions` in interface `ImageConsumer`
    Overrides:
      `setDimensions` in class `ImageFilter`
    Parameters:
      `width` - the width to which to set the width of this `BufferedImageFilter`
      `height` - the height to which to set the height of this `BufferedImageFilter`
    See Also:
      - `ImageConsumer.setDimensions(int, int)`

  - ### setColorModel

    public void setColorModel(ColorModel model)
    Filters the information provided in the `setColorModel` method of the `ImageConsumer` interface.

    If `model` is `null`, this method clears the current `ColorModel` of this `BufferedImageFilter`.

    Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to retrieve pixels from an image should avoid calling this method directly since that operation could result in problems with retrieving the requested pixels.

    Specified by:
      `setColorModel` in interface `ImageConsumer`
    Overrides:
      `setColorModel` in class `ImageFilter`
    Parameters:
      `model` - the `ColorModel` to which to set the `ColorModel` of this `BufferedImageFilter`
    See Also:
      - `ImageConsumer.setColorModel(ColorModel)`

  - ### setPixels

    public void setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize)
    Filters the information provided in the `setPixels` method of the `ImageConsumer` interface which takes an array of bytes.

    Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to retrieve pixels from an image should avoid calling this method directly since that operation could result in problems with retrieving the requested pixels.

    Specified by:
      `setPixels` in interface `ImageConsumer`
    Overrides:
      `setPixels` in class `ImageFilter`
    Parameters:
      `x` - the X coordinate of the upper-left corner of the area of pixels to be set
      `y` - the Y coordinate of the upper-left corner of the area of pixels to be set
      `w` - the width of the area of pixels
      `h` - the height of the area of pixels
      `model` - the specified `ColorModel`
      `pixels` - the array of pixels
      `off` - the offset into the `pixels` array
      `scansize` - the distance from one row of pixels to the next in the `pixels` array
    Throws:
      `IllegalArgumentException` - if width or height are less than zero.
    See Also:
      - `ImageConsumer.setPixels(int, int, int, int, ColorModel, byte[], int, int)`

  - ### setPixels

    public void setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize)
    Filters the information provided in the `setPixels` method of the `ImageConsumer` interface which takes an array of integers.

    Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to retrieve pixels from an image should avoid calling this method directly since that operation could result in problems with retrieving the requested pixels.

    Specified by:
      `setPixels` in interface `ImageConsumer`
    Overrides:
      `setPixels` in class `ImageFilter`
    Parameters:
      `x` - the X coordinate of the upper-left corner of the area of pixels to be set
      `y` - the Y coordinate of the upper-left corner of the area of pixels to be set
      `w` - the width of the area of pixels
      `h` - the height of the area of pixels
      `model` - the specified `ColorModel`
      `pixels` - the array of pixels
      `off` - the offset into the `pixels` array
      `scansize` - the distance from one row of pixels to the next in the `pixels` array
    Throws:
      `IllegalArgumentException` - if width or height are less than zero.
    See Also:
      - `ImageConsumer.setPixels(int, int, int, int, ColorModel, int[], int, int)`

  - ### imageComplete

    public void imageComplete(int status)
    Filters the information provided in the `imageComplete` method of the `ImageConsumer` interface.

    Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to retrieve pixels from an image should avoid calling this method directly since that operation could result in problems with retrieving the requested pixels.

    Specified by:
      `imageComplete` in interface `ImageConsumer`
    Overrides:
      `imageComplete` in class `ImageFilter`
    Parameters:
      `status` - the status of image loading
    Throws:
      `ImagingOpException` - if there was a problem calling the filter method of the `BufferedImageOp` associated with this instance.
    See Also:
      - `ImageConsumer.imageComplete(int)`